/****************************************************************************
** Form implementation generated from reading ui file 'loginbox.ui'
**
** Created: Tue Apr 9 16:11:56 2002
**      by:  The User Interface Compiler (uic)
**
** WARNING! All changes made in this file will be lost!
****************************************************************************/
#include "loginbox.h"

#include <qvariant.h>
#include <klineedit.h>
#include <kpassdlg.h>
#include <ksqueezedtextlabel.h>
#include <qframe.h>
#include <qpushbutton.h>
#include <qlayout.h>
#include <qtooltip.h>
#include <qwhatsthis.h>
#include <kapplication.h>
#include <klocale.h>

#include <iostream>
#include <iomanip>


/* 
 *  Constructs a LoginBox which is a child of 'parent', with the 
 *  name 'name' and widget flags set to 'f'.
 *
 *  The dialog will by default be modeless, unless you set 'modal' to
 *  TRUE to construct a modal dialog.
 */
LoginBox::LoginBox( QWidget* parent,  const char* name, bool modal, WFlags fl, QString h, QString u )
    : QDialog( parent, name, modal, fl )
{
    if ( !name )
	setName( "LoginBox" );

	const QString catalogue = "sqlguipart";
	kl = new KLocale( catalogue, 0 );
	kl->setActiveCatalogue( catalogue );
	kl->setMainCatalogue( "sqlguipart" );


    resize( 450, 145 );
    setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)5, (QSizePolicy::SizeType)5, 0, 0, sizePolicy().hasHeightForWidth() ) );
    setCaption( kl->translate( i18n( "Login" )));
    setSizeGripEnabled( TRUE );
    LoginBoxLayout = new QVBoxLayout( this, 11, 6, "LoginBoxLayout");

    Frame3 = new QFrame( this, "Frame3" );
    Frame3->setFrameShape( QFrame::StyledPanel );
    Frame3->setFrameShadow( QFrame::Raised );
    Frame3Layout = new QGridLayout( Frame3, 1, 1, 11, 6, "Frame3Layout");

    KSqueezedTextLabel2 = new KSqueezedTextLabel( Frame3, "KSqueezedTextLabel2" );
    KSqueezedTextLabel2->setMinimumSize( QSize( 100, 20 ) );
    KSqueezedTextLabel2->setMaximumSize( QSize( 100, 20 ) );
    KSqueezedTextLabel2->setText( kl->translate( i18n( " Host:" )));

    Frame3Layout->addWidget( KSqueezedTextLabel2, 0, 0 );

    host = new KLineEdit( Frame3, "host" );
    host->setMinimumSize( QSize( 300, 20 ) );
		host->setText( h );

    Frame3Layout->addWidget( host, 0, 1 );

    KSqueezedTextLabel3 = new KSqueezedTextLabel( Frame3, "KSqueezedTextLabel3" );
    KSqueezedTextLabel3->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)1, (QSizePolicy::SizeType)0, 0, 0, KSqueezedTextLabel3->sizePolicy().hasHeightForWidth() ) );
    KSqueezedTextLabel3->setMinimumSize( QSize( 100, 20 ) );
    KSqueezedTextLabel3->setMaximumSize( QSize( 100, 20 ) );
    KSqueezedTextLabel3->setText( kl->translate( i18n( " Username:" )));

    Frame3Layout->addWidget( KSqueezedTextLabel3, 1, 0 );

    user = new KLineEdit( Frame3, "user" );
    user->setMinimumSize( QSize( 300, 20 ) );
		user->setText( u );

    Frame3Layout->addWidget( user, 1, 1 );

    KSqueezedTextLabel4 = new KSqueezedTextLabel( Frame3, "KSqueezedTextLabel4" );
    KSqueezedTextLabel4->setMinimumSize( QSize( 100, 20 ) );
    KSqueezedTextLabel4->setMaximumSize( QSize( 100, 20 ) );
    KSqueezedTextLabel4->setText( kl->translate( i18n( " Password:" )));

    Frame3Layout->addWidget( KSqueezedTextLabel4, 2, 0 );

    passwd = new KPasswordEdit( Frame3, "passwd" );
    passwd->setMinimumSize( QSize( 300, 2 ) );

    Frame3Layout->addWidget( passwd, 2, 1 );
    LoginBoxLayout->addWidget( Frame3 );

    Layout1 = new QHBoxLayout( 0, 0, 6, "Layout1");
    QSpacerItem* spacer = new QSpacerItem( 20, 20, QSizePolicy::Expanding, QSizePolicy::Minimum );
    Layout1->addItem( spacer );

    buttonOk = new QPushButton( this, "buttonOk" );
    buttonOk->setText( kl->translate( i18n( "OK" )));
    buttonOk->setAccel( 0 );
    buttonOk->setAutoDefault( TRUE );
    buttonOk->setDefault( TRUE );
    Layout1->addWidget( buttonOk );

    buttonCancel = new QPushButton( this, "buttonCancel" );
    buttonCancel->setText( kl->translate( i18n( "Cancel" )));
    buttonCancel->setAccel( 0 );
    buttonCancel->setAutoDefault( TRUE );
    Layout1->addWidget( buttonCancel );
    LoginBoxLayout->addLayout( Layout1 );

    // signals and slots connections
    connect( host, SIGNAL( returnPressed() ), this, SLOT( slotLogin() ) );
    connect( this, SIGNAL( successfullLogin() ), this, SLOT( accept() ) );
    connect( user, SIGNAL( returnPressed() ), this, SLOT( slotLogin() ));
    connect( passwd, SIGNAL( returnPressed() ), this, SLOT( slotLogin() ));
    connect( buttonOk, SIGNAL( clicked() ), this, SLOT( slotLogin() ));
    connect( buttonCancel, SIGNAL( clicked() ), this, SLOT( reject() ) );

    // tab order
    setTabOrder( host, user );
    setTabOrder( user, passwd );
    setTabOrder( passwd, buttonOk );
    setTabOrder( buttonOk, buttonCancel );
}



LoginBox::~LoginBox()
{
    // no need to delete child widgets, Qt does it all for us
}

void LoginBox::slotSetServer( QString server ){
	host->setText( server );
}

void LoginBox::slotSetUser( QString person ){
	user->setText( person );
}

void LoginBox::slotLogin()
{
  emit( loginRequest( host->text(),user->text() , passwd->password()  ) );
  emit( successfullLogin() );
}

void LoginBox::slotClear()
{
    host->setText(QString::null);
    user->setText(QString::null);
    passwd->setText(QString::null);
}
